import { IDestinationConfig, IDestination } from '../../types';
export declare abstract class Destination implements IDestination {
    batchSize: number;
    recordGenerator: ((row: any) => AsyncIterableIterator<{}>) | undefined;
    batchTransformer: ((rows: any[]) => Promise<any[]>) | undefined;
    disableLoad: boolean;
    constructor(config?: IDestinationConfig);
    loadBatch(data: any[]): Promise<void>;
}
