import { IExcelProcessorConfig, processStream, sheetGetter } from '../types';
import { DirectoryProcessor } from './base/directory-processor';
export declare class ExcelProcessor extends DirectoryProcessor {
    protected hasHeader: boolean | number | undefined;
    protected ignoreEmpty: boolean;
    protected encoding?: string;
    protected fillMergedCells: boolean;
    protected sheets: (string | number)[] | sheetGetter;
    constructor(config: IExcelProcessorConfig);
    process(processStream: processStream): Promise<void>;
}
