"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyHttpAuthorization = exports.getDelimitedGenerator = exports.removeCircularReferencesFromChunk = exports.getValueFromJSONChunk = exports.closeDbConnection = exports.getDb = void 0;
var axios_1 = __importDefault(require("axios"));
var promise_1 = __importDefault(require("mysql2-stream-fix/promise"));
var stream_1 = require("stream");
var cachedDbConnections = new Map();
function getCachedDbConnection(databaseConfig) {
    var dbKey = getDbKey(databaseConfig);
    return cachedDbConnections.get(dbKey);
}
function getDbKey(databaseConfig) {
    if ('driver' in databaseConfig) {
        var configWithoutDriver = __assign({}, databaseConfig);
        delete configWithoutDriver.driver;
        return JSON.stringify(configWithoutDriver);
    }
    return JSON.stringify(databaseConfig);
}
function setCachedDbConnection(databaseConfig, db, close) {
    var dbKey = getDbKey(databaseConfig);
    cachedDbConnections.set(dbKey, { db: db, close: close });
}
function unsetCachedDbConnection(databaseConfig) {
    var dbKey = getDbKey(databaseConfig);
    cachedDbConnections.delete(dbKey);
}
function getDb(databaseConfig, dbType) {
    return __awaiter(this, void 0, void 0, function () {
        var dbConnection, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    dbConnection = getCachedDbConnection(databaseConfig);
                    if (dbConnection) {
                        return [2 /*return*/, dbConnection.db];
                    }
                    _a = dbType;
                    switch (_a) {
                        case 'mssql': return [3 /*break*/, 1];
                        case 'firebird': return [3 /*break*/, 3];
                        case 'mysql': return [3 /*break*/, 5];
                        case 'postgres': return [3 /*break*/, 6];
                    }
                    return [3 /*break*/, 6];
                case 1: return [4 /*yield*/, getMssqlDb(databaseConfig)];
                case 2: return [2 /*return*/, _b.sent()];
                case 3: return [4 /*yield*/, getFirebirdDb(databaseConfig)];
                case 4: return [2 /*return*/, _b.sent()];
                case 5: return [2 /*return*/, getMySqlDb(databaseConfig)];
                case 6: return [2 /*return*/, getPostgresDb(databaseConfig)];
            }
        });
    });
}
exports.getDb = getDb;
function getMySqlDb(databaseConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var dbConnection;
        return __generator(this, function (_a) {
            dbConnection = promise_1.default.createPool(databaseConfig);
            setCachedDbConnection(databaseConfig, dbConnection, dbConnection.end.bind(dbConnection));
            return [2 /*return*/, dbConnection];
        });
    });
}
function getMssqlDb(databaseConfig) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var driver, _b, pool, db;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (!((_a = databaseConfig.driver) !== null && _a !== void 0)) return [3 /*break*/, 1];
                    _b = _a;
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('mssql')); })];
                case 2:
                    _b = _c.sent();
                    _c.label = 3;
                case 3:
                    driver = _b;
                    pool = getMssqlDbPool(driver, databaseConfig);
                    return [4 /*yield*/, pool.connect()];
                case 4:
                    db = _c.sent();
                    setCachedDbConnection(databaseConfig, db, pool.close.bind(pool));
                    return [2 /*return*/, db];
            }
        });
    });
}
function getMssqlDbPool(driver, databaseConfig) {
    var poolConfig = __assign({}, databaseConfig);
    delete poolConfig.driver;
    return new driver.ConnectionPool(__assign({}, databaseConfig));
}
function getPostgresDb(databaseConfig) {
    var pgp = require('pg-promise')({ schema: databaseConfig.schema || 'public' });
    var db = pgp(databaseConfig);
    setCachedDbConnection(databaseConfig, db, pgp.end);
    return db;
}
function getFirebirdDb(databaseConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var Firebird, db;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    Firebird = databaseConfig.useClavizNodeFirebird ? require('claviz-node-firebird') : require('node-firebird');
                    return [4 /*yield*/, new Promise(function (resolve, reject) {
                            Firebird.attach(databaseConfig, function (err, db) {
                                if (err)
                                    reject(err);
                                else
                                    resolve(db);
                            });
                        })];
                case 1:
                    db = _a.sent();
                    setCachedDbConnection(databaseConfig, db, db.detach.bind(db));
                    return [2 /*return*/, db];
            }
        });
    });
}
function closeDbConnection(databaseConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var dbConnection;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dbConnection = getCachedDbConnection(databaseConfig);
                    if (!dbConnection) return [3 /*break*/, 2];
                    return [4 /*yield*/, dbConnection.close()];
                case 1:
                    _a.sent();
                    unsetCachedDbConnection(databaseConfig);
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
exports.closeDbConnection = closeDbConnection;
function getValueFromJSONChunk() {
    return new stream_1.Transform({
        objectMode: true,
        transform: function (chunk, encoding, callback) {
            if (chunk.value) {
                this.push(chunk.value);
            }
            callback();
        }
    });
}
exports.getValueFromJSONChunk = getValueFromJSONChunk;
function removeCircularReferencesFromChunk() {
    return new stream_1.Transform({
        objectMode: true,
        transform: function (chunk, encoding, callback) {
            function getCircularReplacer() {
                var seen = new WeakSet();
                return function (key, value) {
                    if (typeof value === "object" && value !== null) {
                        if (seen.has(value)) {
                            return;
                        }
                        seen.add(value);
                    }
                    return value;
                };
            }
            this.push(JSON.parse(JSON.stringify(chunk, getCircularReplacer())));
            callback();
        }
    });
}
exports.removeCircularReferencesFromChunk = removeCircularReferencesFromChunk;
function getDelimitedGenerator(_a) {
    var readStream = _a.readStream, hasHeader = _a.hasHeader;
    var header = [];
    var processRow = function (_a) {
        var raw = _a.raw, record = _a.record;
        if (hasHeader && !header.length) {
            header = record.map(function (x) { return x.trim(); });
        }
        else {
            var obj = void 0;
            if (header.length) {
                obj = Object.fromEntries(header.map(function (x, i) { return [x, record[i]]; }));
            }
            return { header: header, arr: record, obj: obj, row: raw };
        }
    };
    var generator = function () {
        return __asyncGenerator(this, arguments, function () {
            var readStream_1, readStream_1_1, row, result, e_1_1;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 7, 8, 13]);
                        readStream_1 = __asyncValues(readStream);
                        _b.label = 1;
                    case 1: return [4 /*yield*/, __await(readStream_1.next())];
                    case 2:
                        if (!(readStream_1_1 = _b.sent(), !readStream_1_1.done)) return [3 /*break*/, 6];
                        row = readStream_1_1.value;
                        result = processRow(row);
                        if (!result) return [3 /*break*/, 5];
                        return [4 /*yield*/, __await(result)];
                    case 3: return [4 /*yield*/, _b.sent()];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5: return [3 /*break*/, 1];
                    case 6: return [3 /*break*/, 13];
                    case 7:
                        e_1_1 = _b.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 13];
                    case 8:
                        _b.trys.push([8, , 11, 12]);
                        if (!(readStream_1_1 && !readStream_1_1.done && (_a = readStream_1.return))) return [3 /*break*/, 10];
                        return [4 /*yield*/, __await(_a.call(readStream_1))];
                    case 9:
                        _b.sent();
                        _b.label = 10;
                    case 10: return [3 /*break*/, 12];
                    case 11:
                        if (e_1) throw e_1.error;
                        return [7 /*endfinally*/];
                    case 12: return [7 /*endfinally*/];
                    case 13: return [2 /*return*/];
                }
            });
        });
    };
    return generator;
}
exports.getDelimitedGenerator = getDelimitedGenerator;
function applyHttpAuthorization(connection, authorizationRequest) {
    return __awaiter(this, void 0, void 0, function () {
        var authorizationResponse, authorizationToken, applyTo;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!authorizationRequest) return [3 /*break*/, 2];
                    return [4 /*yield*/, axios_1.default(authorizationRequest.connection)];
                case 1:
                    authorizationResponse = _b.sent();
                    authorizationToken = authorizationResponse.data[authorizationRequest.sourceField];
                    applyTo = authorizationRequest.applyTo === 'header' ? 'headers' : 'params';
                    connection[applyTo] = __assign(__assign({}, connection[applyTo]), (_a = {}, _a[authorizationRequest.destinationField] = authorizationRequest.prefix ? "" + authorizationRequest.prefix + authorizationToken : authorizationToken, _a));
                    _b.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
exports.applyHttpAuthorization = applyHttpAuthorization;
